routes/web.php
<?php

//    use App\User;

//    use App\News;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//    Route::group(['middleware' => ['web']], function () {
        Auth::routes();
//    });
Route::get('/', 'WelcomeController@index')->name('home');
    Route::post('/feedback', 'WelcomeController@feedback')->name('feedback');
Route::group(['middleware' => ['web'], 'prefix' => 'admin'], function (){

    Route::group(['namespace' => '\Inani\Larapoll\Http\Controllers'], function(){

        Route::middleware(["role:author,editor,admin,super_admin"])->group(function () {
            Route::get('/polls', ['uses' => 'PollManagerController@index', 'as' => 'poll.index']);
            Route::get('/polls/home', ['uses' => 'PollManagerController@home', 'as' => 'poll.home']);
            Route::get('/polls/create', ['uses' => 'PollManagerController@create', 'as' => 'poll.create']);
            Route::get('/polls/{poll}', ['uses' => 'PollManagerController@edit', 'as' => 'poll.edit']);
            Route::patch('/polls/{poll}', ['uses' => 'PollManagerController@update', 'as' => 'poll.update']);
            Route::delete('/polls/{poll}', ['uses' => 'PollManagerController@remove', 'as' => 'poll.remove']);
            Route::patch('/polls/{poll}/lock', ['uses' => 'PollManagerController@lock', 'as' => 'poll.lock']);
            Route::patch('/polls/{poll}/unlock', ['uses' => 'PollManagerController@unlock', 'as' => 'poll.unlock']);
            Route::post('/polls', ['uses' => 'PollManagerController@store', 'as' => 'poll.store']);
            Route::get('/polls/{poll}/options/add', ['uses' => 'OptionManagerController@push', 'as' => 'poll.options.push']);
            Route::post('/polls/{poll}/options/add', ['uses' => 'OptionManagerController@add', 'as' => 'poll.options.add']);
            Route::get('/polls/{poll}/options/remove', ['uses' => 'OptionManagerController@delete', 'as' => 'poll.options.remove']);
            Route::delete('/polls/{poll}/options/remove', ['uses' => 'OptionManagerController@remove', 'as' => 'poll.options.remove']);
        });

        Route::post('/vote/polls/{poll}', 'VoteManagerController@vote')->name('poll.vote');
    });


    Route::get('/', 'HomeController@index')->name('admin');
//    Route::get('/admin/chart', 'HomeController@chart')->name('admin.chart');
//    Route::get('/admin/users/{user}/reset', 'UsersController@resetscore')->name('admin.score.reset')->middleware('role:user,super_user,admin,super_admin');

//    Route::group(['middleware' => ['pay,role:super_admin']], function () {
//        Route::get('/admin/users/{user}/parent/add', 'UsersController@parentScoreAdd')->name('admin.score.add');
//        Route::get('/admin/users/{user}/parent/remove', 'UsersController@parentScoreRemove')->name('admin.score.remove');
//        Route::get('/admin/users/{user}/parent/score/{score}', 'UsersController@parentScoreToChild')->name('parent.score');
//    });

//    Route::put('/admin/users/{user}/assign', 'UsersController@assigned')->name('users.assigned')->middleware('role:super_user,author,editor,admin,super_admin');
//    Route::get('/admin/users/{user}/assign', 'UsersController@assign')->name('users.assign')->middleware('role:super_user,author,editor,admin,super_admin');

//    Route::put('/exams/{test}/assigned_pupil', 'UsersController@assigned_pupil')->name('users.assigned.pupil')->middleware('role:super_user,author,editor,admin,super_admin');
//    Route::get('/exams/{test}/assign_pupil', 'UsersController@assign_pupil')->name('users.assign.pupil')->middleware('role:super_user,author,editor,admin,super_admin');

    Route::resource('/pages', 'PagesController')->middleware('role:author,editor,admin,super_admin');
    Route::resource('/news', 'NewsController')->middleware('role:author,editor,admin,super_admin');

    Route::resource('/users', 'UsersController')->except('create,destroy')->middleware('role:author,editor,admin,super_admin');

    Route::get('/profile', 'UsersController@editCurrent')->name('profile.edit')->middleware('auth');
    Route::put('/profile', 'UsersController@updateCurrent')->name('profile.update')->middleware('auth');

    Route::resource('/adress', 'AdressController')->except('create,destroy')->middleware('role:author,editor,admin,super_admin');


    Route::get('/users/new', 'UsersController@create')->middleware('role:admin,super_admin');

    Route::delete('/users/{user}', 'UsersController@destroy')->name('users.destroy')->middleware('role:admin,super_admin');
    Route::resource('/roles', 'RolesController')->middleware('role:super_admin');
    Route::resource('/topics', 'TopicController')->middleware('role:admin,super_admin');

//    Route::resource('/admin/tests', 'TestsController')->middleware('role:super_user,author,editor,admin,super_admin');

//    Route::resource('/admin/questions', 'QuestionController')->except('index,create')->middleware('role:author,editor,admin,super_admin');
//    Route::get('/admin/questions/create/{test_id}', 'QuestionController@create')->name('questions.create')->middleware('role:author,editor,admin,super_admin');

//    Route::resource('/admin/answers', 'AnswerController')->except('index,create')->middleware('role:author,editor,admin,super_admin');
//    Route::get('/admin/answers/create/{question_id}', 'AnswerController@create')->name('answers.create')->middleware('role:author,editor,admin,super_admin');

//    Route::get('/testing/exams', 'TestStartController@list')->name('exams.list')->middleware('role:super_user,admin,super_admin');
//    Route::get('/testing/exams/result/{id}', function ($id) {
//        $test = \App\TestCompleted::find($id);
//        return view('tests.result', ['test' => $test]);
//    })->name('exams.result');//->middleware('role:super_user,admin,super_admin');
//    Route::post('/testing/exams/{id}/control', 'TestStartController@control')->name('exams.control')->middleware('role:super_user,admin,super_admin');//->middleware('avaible.test');
//    Route::get('/testing/exams/{id}/start', 'TestStartController@execute')->name('exams.start')->middleware('role:super_user,admin,super_admin');//->middleware('avaible.test');
});
//=======================================================
//Route::get('clear-cache', function() {
//
//    Artisan::call('cache:clear');
//    return "Кэш очищен!";
//
//});

//Route::get('lang/{locale}', function ($locale) {
//
//    if (in_array($locale, \Config::get('app.locales'))) {
//        Session::put('locale', $locale);
//    }
//
//    return redirect()->back();
//
//});
//    Route::get('contact', function () {
//        return view('contact');
//    })->name('contact');
//    ===========================================
Route::get('{slug}', 'PagesController@showBySlug')->name('pages.slug');
Route::get('news/{slug}', 'NewsController@showBySlug')->name('news.slug');
//Route::get('contact', function () {
//    return view('contact');
//})->name('contact');


//
//Route::get('url/generate-shorten-link', 'ShortLinkController@index')->middleware('role:admin,super_admin');
//Route::post('url/generate-shorten-link', 'ShortLinkController@store')->name('generate.shorten.link.post')->middleware('role:admin,super_admin');
//
//Route::get('url/{code}', 'ShortLinkController@shortenLink')->name('shorten.link')->middleware('role:user');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Str;
use Inani\Larapoll\Traits\Voter;
use tizis\laraComments\Traits\Commenter;

class User extends Authenticatable
{
    use Notifiable;
    use Voter;
    use Commenter;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password', 'role_id', 'score', 'current_test_id', 'phone', 'adress_id', 'api_token',
        'sms_notification', 'email_notification', 'push_notification',
        'where_passport', 'when_passport', 'serial_passport', 'number_passport',
        'birthday', 'firstname', 'lastname', 'avatar'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function isAdmin()
    {
        if($this->role_id >= 5)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    public function hasRole($role) {
        if($this->role->type === $role)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    public function hasRoles(array $roles) {
        $result = false;
        foreach ($roles as $role) {
            if($this->role->type === $role)
            {
                $result = true;
            }
        }
        return $result;
    }

    public function role()
    {
        return $this->belongsTo('App\Role');
    }

    public function adress()
    {
        return $this->belongsTo('App\Adress');
    }

    public function tests_complited() //Завершенные опросы
    {
        return $this->hasMany('App\TestCompleted');
    }

    public function parentsFromFamily($id) //Все родители семьи
    {
        $parent = $this->family($id)->where('role_id', 2);
        return $parent;
    }

    public function childsFromFamily($id) //Все дети семьи
    {
        $childs = $this->family($id)->where('role_id', 1);
        return $childs;
    }

    public function family($id = null) //Все члены семьи
    {
        if ($id === null) $id = Auth::user()->family_id;

        $users = DB::table('users')->where('family_id', $id)->orWhere('id', $id)->get();
        return $users;
    }

    static public function childs() //Все дети
    {
        $id = Auth::user()->family_id;

//        $users = DB::table('users')->where('family_id', $id)->orWhere('id', $id)->get();
        $users = User::All()->where('id', $id);
        $users = $users->merge(User::All()->where('family_id', Auth::user()->id));//User::All()->where('family_id', Auth::user()->id));

        if (Auth::user()->family_id != null) {
            $users = $users->merge(User::All()->where('family_id', Auth::user()->family_id));
            $users = $users->merge(User::All()->where('id', Auth::user()->family_id));
        }
        return $users;
    }

    public function generateToken()
    {
        $this->api_token = Str::random(80);
        $this->save();

        return $this->api_token;
    }
//$users = User::All()->where('id', $id);
//$users = $users->merge(User::All()->where('family_id', Auth::user()->id));//User::All()->where('family_id', Auth::user()->id));
//
//if (Auth::user()->family_id != null) {
//$users = $users->merge(User::All()->where('family_id', Auth::user()->family_id));
//$users = $users->merge(User::All()->where('id', Auth::user()->family_id));
//}
}

app/Http/Controllers/Users/AdressController.php
<?php

namespace App\Http\Controllers;

use App\Adress;
use App\Http\Requests\AdressValidation;
use Illuminate\Http\Request;

class AdressController extends Controller
{
    public function index()
    {
        $adresses = Adress::all();
        return view('adresses.index', ['adresses' => $adresses]);
    }

    public function create()
    {
        return view('adresses.create');
    }

    public function store(AdressValidation $request)
    {
        $role = Adress::create($request->all());

        return redirect()->route('adresses.show', $role);
    }

    public function edit($id)
    {
        $role = Adress::find($id);

        return view('adresses.edit', ['role' => $role]);
    }

    public function show($id)
    {
        $role = Adress::find($id);

        return view('adresses.view', ['role' => $role]);
    }

    public function update(AdressValidation $request, $id)
    {
        $role = Adress::find($id);

        $role->fill($request->all());
        $role->save();

        return redirect()->route('adresses.index');
    }

    public function destroy($id)
    {
        Adress::find($id)->delete($id);

        return redirect()->route('adresses.index');
    }
}

app/Http/Controllers/Users/RolesController.php
<?php

namespace App\Http\Controllers;

use App\Role;
use App\Http\Requests\RoleValidation;
use Illuminate\Http\Request;

class RolesController extends Controller
{
    public function index()
    {
        $roles = Role::all();
        return view('roles.index', ['roles' => $roles]);
    }

    public function create()
    {
        return view('roles.create');
    }

    public function store(RoleValidation $request)
    {
        $role = Role::create($request->all());

        return redirect()->route('roles.show', $role);
    }

    public function edit($id)
    {
        $role = Role::find($id);

        return view('roles.edit', ['role' => $role]);
    }

    public function show($id)
    {
        $role = Role::find($id);

        return view('roles.view', ['role' => $role]);
    }

    public function update(RoleValidation $request, $id)
    {
        $role = Role::find($id);

        $role->fill($request->all());
        $role->save();

        return redirect()->route('roles.index');
    }

    public function destroy($id)
    {
        Role::find($id)->delete($id);

        return redirect()->route('roles.index');
    }
}

resources/views/users/assign.blade.php
@extends('layouts.app')

@section('sidebar')
    @parent

@stop

@section('content')
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        {{ Breadcrumbs::render('user_edit', $user) }}
                    </div>
                    <div class="card-body">
                        <div class="form-group">

                            {!! Form::open(['route' => ['users.assigned', $user->id], 'method' => 'PUT']) !!}

                            <dd>
                                <label for="current_test_id">Опросы</label>
                                <input type="text" class="form-control" name="current_test_id" value="{{ $user->current_test_id }}">
                                @if ($errors->has('current_test_id'))
                                    <b class="alert alert-danger">{{ $errors->first() }}</b>
                                @endif
                            </dd>
                            <button class="btn btn-warning" type="submit">Назначить</button>

                            {!! Form::close() !!}

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop

resources/views/users/assign_pupil.blade.php
@extends('layouts.app')

@section('sidebar')
    @parent

@stop

@section('content')
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
{{--                        {{ Breadcrumbs::render('user_edit', $user) }}--}}
                        Назначение опроса
                    </div>
                    <div class="card-body">
                        <div class="form-group">

                            {!! Form::open(['route' => ['users.assigned.pupil', $test_id], 'method' => 'PUT']) !!}

                            <dd>
                                <label for="user_id">Ученик</label>
                                <select class="form-control" name="user_id">
                                    @foreach($users as $user)
                                        <option value="{{ $user->id }}">{{ $user->name }}</option>
                                    @endforeach
                                </select>
                                @if ($errors->has('current_test_id'))
                                    <b class="alert alert-danger">{{ $errors->first() }}</b>
                                @endif
                            </dd>
                            <button class="btn btn-warning" type="submit">Рекомендовать</button>

                            {!! Form::close() !!}

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop

resources/views/users/index.blade.php
@extends('layouts.admin')

@section('content')

    <section class="admin-panel-content">
        <form class="admin-panel-content__search">
            <input type="text" placeholder="Поиск...">
        </form>

        <div class="news-table">
            <div class="news-table__heading">
                <h3>Пользователи</h3>
                <a href="{{ route('users.create') }}" class="news-table__heading-new">
                    <svg class="icon icon-plus">
                        <use xlink:href="./img/sprites/main-sprite.svg#icon-plus"></use>
                    </svg>
                    <span>Новый</span>
                </a>
            </div>
            <div class="news-table-content">
                <table>
                    <thead>
                        <tr>
                            @if( Auth::user()->hasRoles(['super_admin']) )
                                <td>ID</td>
                            @endif
                            <td>{{ __('Name') }}</td>
                            <td>Email</td>
                            <td>{{ __('Phone') }}</td>
                            <td>{{ __('Role') }}</td>
    {{--                                    <td>{{ __('Score') }}</td>--}}

    {{--                                    @if ($user->hasRoles(['user']) )--}}
    {{--                                        <td>{{ __('Score') }}</td>--}}
    {{--                                        <td>{{ __('Class') }}</td>--}}
    {{--                                    @endif--}}

                            <td>{{ __('Action') }}</td>
                        </tr>
                    </thead>
                    <tbody>

                    @foreach($users as $user)
                        <tr>
                            @if (Auth::user()->hasRoles(['super_admin']))
                                <td>{{ $user->id }}</td>
                            @endif
                            <td>{{ $user->name }}</td>
                            <td>{{ $user->email }}</td>
                            <td>{{ $user->phone }}</td>
                            <td>{{ $user->role->name }}</td>
                            <td>
                                <span class="news-table-more">
                                    <a href="#pixel" class="news-table-more__trigger">
                                        <svg class="icon icon-more">
                                            <use xlink:href="/design/img/sprites/main-sprite.svg#icon-more"></use>
                                        </svg>
                                    </a>
                                    <span class="news-table-more__popup">
                                        <a href="{{ route('users.edit', $user->id) }}">Редактировать</a>
                                    </span>
                                </span>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </section>

@endsection

resources/views/users/view.blade.php
@extends('layouts.app')

@section('sidebar')
    @parent

@stop

@section('content')
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h1>Пользователь - {{ $user->name }}</h1>
                    </div>
                    <div class="card-body">
                        <div class="form-group">

                            {!! Form::open(['route' => ['users.update', $user->id], 'method' => 'PUT']) !!}
                            <dd>
                                <label for="name">{{ __('Name') }}</label>
                                <input type="text" class="form-control" name="name" disabled value="{{ $user->name }}">
                            </dd>
                            <dd>
                                <label for="email">E-mail</label>
                                <input type="email" class="form-control" name="email" disabled value="{{ $user->email }}">
                            </dd>
                            <dd>
                                <label for="phone">{{ __('Phone') }}</label>
                                <input type="text" class="form-control" name="phone" disabled value="{{ $user->phone }}">
                            </dd>
                            {!! Form::close() !!}

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop